# Mesa bugzilla: http://bugs.freedesktop.org/show_bug.cgi?id=<bug number>
# (hence MESA#<bug number>).

%define	name			mesa
%define version			6.5.2
%define release			%mkrel 9
%define priority		500

%define eglname			mesaegl
%define glname			mesagl
%define gluname			mesaglu
%define glutname		mesaglut
%define glwname			mesaglw
%define eglmajor		1
%define glmajor			1
%define glumajor		1
%define glutmajor		3
%define glwmajor		1
%define libeglname              %mklibname %{eglname} %{eglmajor}
%define libglname		%mklibname %{glname} %{glmajor}
%define libgluname		%mklibname %{gluname} %{glumajor}
%define libglutname		%mklibname %{glutname} %{glutmajor}
%define libglwname		%mklibname %{glwname} %{glwmajor}

%define oldlibglname		%mklibname MesaGL 1
%define oldlibgluname		%mklibname MesaGLU 1
%define oldlibglutname		%mklibname Mesaglut 3

%define mesasrcdir		%{_prefix}/src/Mesa/
%define driver_dir		%{_libdir}/dri

%define enable_egl		0

#FIXME: (for 386/485) unset SSE, MMX and 3dnow flags
#FIXME: (for >=i586)  disable sse
#       SSE seems to have problem on some apps (gtulpas) for probing.
%define	dri_drivers_i386	"i810 i915 i965 mga mach64 r128 r200 r300 radeon savage sis unichrome tdfx"

%define	dri_drivers_x86_64	"mach64 i810 i915 i965 mga mach64 r128 r200 r300 radeon savage sis unichrome tdfx"
%define	dri_drivers_ppc		"mach64 r128 r200 r300 radeon tdfx"
%define	dri_drivers_ppc64	""
%define	dri_drivers_ia64	"i810 i915 i965 mga r128 r200 radeon"
%define	dri_drivers_alpha	"mga r128 r200 radeon"
%define	dri_drivers_sparc	"ffb mach64 mga radeon savage"
%define	dri_drivers		%{expand:%{dri_drivers_%{_arch}}}

Name:		%{name}
Version: 	%{version}
Release: 	%{release}
Summary:	OpenGL 1.4 compatible 3D graphics library
Group:		System/Libraries
BuildRequires:	tcl
BuildRequires:	texinfo
BuildRequires:	makedepend
BuildRequires:	libexpat-devel
BuildRequires:	x11-proto-devel >= 1.0.0
BuildRequires:	libx11-devel >= 1.0.0
BuildRequires:	libdrm-devel >= 2.0.1
BuildRequires:	libxext-devel >= 1.0.0
BuildRequires:	libxxf86vm-devel >= 1.0.0
BuildRequires:	libxmu-devel >= 1.0.0
BuildRequires:	libxi-devel >= 1.0.0
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL:		http://www.mesa3d.org
Source0:	http://prdownloads.sourceforge.net/mesa3d/MesaLib-%{version}.tar.bz2
Source1:	http://prdownloads.sourceforge.net/mesa3d/MesaDemos-%{version}.tar.bz2
Source2:	http://prdownloads.sourceforge.net/mesa3d/MesaGLUT-%{version}.tar.bz2
Source3:	mesa-source-file-generator
Source4:	Mesa-icons.tar.bz2
Source5:	mesa-driver-install

# DRI modules are not under /usr/X11R6 anymore
Patch2:		mesa-6.5.1-default_dri_dir.patch
# Install EGL header files and fixes other minor compilations problems when enabling EGL
Patch3:		mesa-egl_support.patch
# static inline functions are broken on some architetures
Patch6:		mesa-6.5-drop-static-inline.patch
# In some cases radeon may have 0 bits depth
Patch7:		mesa-radeon-0depthbits.patch
# Fix compilation on x86_64 
Patch9:		mesa-6.5-x86_64-fix-build.patch
# Disable compilation of broken demos
Patch10:	mesa-6.5-xdemos_remove_broken.patch
# Fix linux-dri so it can be used for all archs (thanks Christiaan Welvaart)
Patch13:	Mesa-6.5.1-linux-dri-config.patch
# Disable some checks making Google Earth work on r300
Patch14:	mesa-6.5.1-google_earth_support.patch
# Fix moving DRI windows on the screen by updating the drawable info
Patch15:	mesa-6.5.2-mga_fix_dri_window_move.patch
# remove unfinished GLX_ARB_render_texture
Patch43:	mesa-6.5.2-no-ARB_render_texture.patch
# fix some crashs when a mesa context could not be found
Patch44:	mesa-6.5.2-check_context.patch

#
Patch100:	mesa-6.5.2-build-config.patch
Patch101:	mesa-6.5.2-asm_pic.patch
Patch102:	mesa-6.5.2-hush-synthetic-visual-warning.patch
Patch103:	mesa-6.5.2-visibility.patch
Patch104:	mesa-6.5.2-r300-parallel-build.patch
Patch105:	mesa-6.5.2-xserver-1.1-source-compat.patch

Patch200: mesa-6.5.2-git-i915tex-intelWindowMoved.patch
Patch201: mesa-6.5.2-git-i965-bug9045.patch
Patch202: mesa-6.5.2-git-i965-bug9237.patch
Patch203: mesa-6.5.2-git-i965-fix-crash-wine.patch
Patch204: mesa-6.5.2-git-i915tex-advertising.patch
Patch205: mesa-6.5.2-git-i965-sarea.patch
Patch206: mesa-6.5.2-git-i965-inteldebug.patch
Patch207: mesa-6.5.2-git-i965-flowmode.patch
Patch208: mesa-6.5.2-git-i965-ARB_occlusion_query.patch
Patch209: mesa-6.5.2-git-i965-maxprim.patch
Patch210: mesa-6.5.2-git-i965-bug9201.patch
Patch211: mesa-6.5.2-git-i965-bug9625.patch
Patch212: mesa-6.5.2-git-i915tex-randr-resizing.patch
Patch213: mesa-6.5.2-git-i915tex-relocation.patch
Patch214: mesa-6.5.2-git-i965-glxswapcontrol.patch
Patch215: mesa-6.5.2-git-i965-static-buffer-bug9604.patch
Patch216: mesa-6.5.2-git-i915-vertexfog-bug9686.patch
Patch217: mesa-6.5.2-git-mach64-bug7260.patch
Patch218: mesa-6.5.2-git-mach64-bug7790.patch
Patch219: mesa-6.5.2-git-mach64-bug7861.patch
Patch220: mesa-6.5.2-git-r200-WoW-bug8250.patch
Patch221: mesa-6.5.2-git-radeon-radeonClear.patch
Patch222: mesa-6.5.2-git-r300-fragprog.patch
Patch223: mesa-6.5.2-git-r300-fragprog-correct.patch
Patch224: mesa-6.5.2-git-r300-vertex-position.patch
Patch225: mesa-6.5.2-git-swrast-bug9345.patch
Patch226: mesa-6.5.2-git-VBO-state-bug9445.patch
Patch227: mesa-6.5.2-git-32bit-Z-buffer.patch
Patch228: mesa-6.5.2-git-PolygonMode-bug9578.patch
Patch229: mesa-6.5.2-git-CheckArrayBounds-bug9285.patch
Patch230: mesa-6.5.2-git-GetVertexAttribPointerv-bug9628.patch
Patch231: mesa-6.5.2-git-main-mem-leak.patch
Patch232: mesa-6.5.2-git-glxext-mem-leak.patch
Patch233: mesa-6.5.2-git-tnl-bug9856.patch
Patch234: mesa-6.5.2-git-fd-bug9684.patch
Patch235: mesa-6.5.2-git-n_dot_h-bug9977.patch
Patch237: mesa-6.5.2-git-unichrome-CN700.patch
Patch238: mesa-6.5.2-git-r300-call-radeonsetcliprects.patch
Patch239: mesa-6.5.2-git-radeon-adapt-cliprect-fixes.patch
Patch240: mesa-6.5.2-git-r200-call-radeonsetcliprects.patch
Patch241: mesa-6.5.2-git-r200-simplify-r200setcliprects.patch
Patch242: mesa-6.5.2-git-unichrome-screen-offset-bug9965.patch
Patch243: mesa-6.5.2-git-i915-add-i945gme.patch
Patch244: mesa-6.5.2-git-i915-add-g33.patch
Patch245: mesa-6.5.2-git-i965-add-i965gm.patch
Patch246: mesa-6.5.2-git-i965-add-i965gme.patch
Patch247: mesa-6.5.2-git-i965-badcast.patch
Patch248: mesa-6.5.3-git-nexuiz-sigsev-bug9170.patch
Patch249: mesa-6.5.2-git-i965-unorm-bug11742.patch
Patch250: mesa-6.5.2-git-fix-memleak-bug11791.patch
Patch251: mesa-6.5.2-git-fix-memleak-bug11793.patch
Patch252: mesa-6.5.2-git-fix-doublefree-bug11808.patch
Patch253: mesa-6.5.2-git-fix-invalid-pointer-in-bezier-bug11807.patch
Patch254: mesa-6.5.2-git-fix-overflow-stencil-value-bug11805.patch
Patch255: mesa-6.5.2-git-fix-swizzle-error-test-bug11881.patch
Patch256: mesa-6.5.2-git-unichrome-fix-potential-null-dereference-bug11879.patch
Patch257: mesa-6.5.2-git-i810-move-free-after-dereference-bug11878.patch
Patch258: mesa-6.5.2-git-fix-byte-swap-glint-stencil-bug11909.patch
Patch259: mesa-6.5.2-git-fix-spantmp-inline-asm-bug11931.patch
Patch260: mesa-6.5.2-git-i965-fix-segfault-with-max-texture-unit-bug9829.patch
Patch261: mesa-7.0.1-via_null_deref2.patch
Patch262: mesa-6.5.2-git-fix-segfault-in-display-list-bug11314.patch
Patch263: mesa-6.5.2-git-demos-fix-glutinit-calls-bug11486.patch
Patch264: mesa-6.5.2-git-fixlogic-op-bug11133.patch
Patch265: mesa-6.5.2-git-fix-GLX_STEREO-bug11705.patch
Patch266: mesa-6.5.2-git-fix-zoomed-depth-copies-bug10608.patch
Patch267: mesa-6.5.2-git-fix-negative-zoom-factor-bug10636.patch
Patch268: mesa-6.5.2-git-ARB_MESA-in-extension-check-bug10126.patch

License:	MIT
Requires:	%{libglname} = %{version}-%{release}
Provides:	hackMesa = %{version}
Obsoletes:	hackMesa <= %{version}
Provides:	Mesa = %{version}
Obsoletes:	Mesa < %{version}

%package	source
Summary:	Source files required for the Xorg 7.0 to enable glx support
Group:		Development/C
Requires:	%{libglname}-devel >= %{version}

%if %{enable_egl}
%package -n	%{libeglname}
Summary:	Files for Mesa (EGL libs)
Group:		System/Libraries

%package -n	%{libeglname}-devel
Summary:	Development files for Mesa (EGL libs)
Group:		Development/C
Requires:	%{name} = %{version}
Provides:	EGL-devel
%endif

%package -n	%{libglname}
Summary:	Files for Mesa (GL and GLX libs)
Group:		System/Libraries
Obsoletes:	%{oldlibglname} < 6.4 
Provides:	%{oldlibglname} = %{version}-%{release}

%package -n	%{libglname}-devel
Summary:	Development files for Mesa (OpenGL compatible 3D lib)
Group:		Development/C
Requires:	%{name} = %{version}
Provides:	lib%{glname}-devel = %{version}-%{release}
Provides:	%{glname}-devel = %{version}-%{release}
Provides:	GL-devel
Obsoletes:	%{oldlibglname}-devel < 6.4
Provides:	%{oldlibglname}-devel = %{version}-%{release}
Provides:	libMesaGL-devel = %{version}-%{release}
Provides:	MesaGL-devel = %{version}-%{release}

%package -n	%{libgluname}
Summary:	Files for Mesa (GLU libs)
Group:		System/Libraries
Obsoletes:	%{oldlibgluname} < 6.4
Provides:	%{oldlibgluname} = %{version}-%{release}

%package -n	%{libgluname}-devel
Summary:	Development files for GLU libs
Group:		Development/C
Requires:	%{libgluname} = %{version}-%{release}
Provides:	lib%{gluname}-devel = %{version}-%{release}
Provides:	%{gluname}-devel = %{version}-%{release}
Obsoletes:	%{oldlibgluname}-devel < 6.4
Provides:	%{oldlibgluname}-devel = %{version}-%{release}
Provides:	libMesaGLU-devel = %{version}-%{release}
Provides:	MesaGLU-devel = %{version}-%{release} 

%package -n	%{libglutname}
Summary:	Files for Mesa (glut libs)
Group:		System/Libraries
Requires:	%{libgluname} = %{version}-%{release}
Provides:	Mesa-common = %{version}-%{release} hackMesa-common = %{version}
Obsoletes:	Mesa-common <= %{version} hackMesa-common <= %{version}
Obsoletes:	%{oldlibglutname} < 6.4
Provides:	%{oldlibglutname} = %{version}-%{release}

%package -n	%{libglutname}-devel
Summary:	Development files for glut libs
Group:		Development/C
Requires:	%{libglutname} = %{version}-%{release} %{libgluname}-devel = %{version}-%{release}
Provides:	lib%{glutname}-devel = %{version}-%{release} 
Provides:	%{glutname}-devel = %{version}-%{release} 
Obsoletes:	%{oldlibglutname}-devel < 6.4
Provides:	%{oldlibglutname}-devel = %{version}-%{release}
Provides:	libMesaGLUT-devel = %{version}-%{release}
Provides:	MesaGLUT-devel = %{version}-%{release}

%package -n	%{libglwname}
Summary:	Files for Mesa (glw libs)
Group:		System/Libraries
Provides:	Mesa-common = %{version}-%{release} hackMesa-common = %{version}
Obsoletes:	Mesa-common <= %{version} hackMesa-common <= %{version}

%package -n	%{libglwname}-devel
Summary:	Development files for glw libs
Group:		Development/C
Requires:	%{libglwname} = %{version}-%{release}
Provides:	lib%{glwname}-devel = %{version}-%{release} 
Provides:	%{glwname}-devel = %{version}-%{release} 

%package	common-devel
Summary:	Meta package for mesa devel
Group:		Development/C
Provides:	Mesa-common-devel = %{version}-%{release} 
Provides:	hackMesa-common-devel = %{version}
Obsoletes:	Mesa-common-devel < %{version} 
Obsoletes:	hackMesa-common-devel < %{version}
Requires:	%{libglname}-devel = %{version}
Requires:	%{libglwname}-devel = %{version}
Requires:	%{libgluname}-devel = %{version}
Requires:	%{libglutname}-devel = %{version}

%package	demos
Summary:	Demos for Mesa (OpenGL compatible 3D lib)
Group:		Graphics
Requires:	%{name} >= %{version}
Provides:	hackMesa-demos = %{version}
Obsoletes:	hackMesa-demos <= %{version}
Obsoletes: 	Mesa-demos < 6.4
Provides:	Mesa-demos = %{version}-%{release}

%description
Mesa is an OpenGL 1.4 compatible 3D graphics library.

%description	source
Mesa is an OpenGL 1.4 compatible 3D graphics library.

Source files required by the Xorg to enable glx support.

%description common-devel
Mesa common metapackage devel

%if %{enable_egl}
%description -n	%{libeglname}
Mesa is an OpenGL 1.4 compatible 3D graphics library.
EGL parts.

%description -n	%{libeglname}-devel
Mesa is an OpenGL 1.4 compatible 3D graphics library.
EGL development parts.
%endif

%description -n	%{libglname}
Mesa is an OpenGL 1.4 compatible 3D graphics library.
GL and GLX parts.

%description -n	%{libglname}-devel
Mesa is an OpenGL 1.4 compatible 3D graphics library.

This package contains the headers needed to compile Mesa programs.

%description -n	%{libgluname}
GLU is the OpenGL Utility Library.
It provides a number of functions upon the base OpenGL library to provide
higher-level drawing routines from the more primitive routines provided by
OpenGL.

%description -n	%{libgluname}-devel
This package contains the headers needed to compile programs with GLU.

%description -n	%{libglutname}
GLUT (OpenGL Utility Toolkit) is a addon library for OpenGL programs. It
provides them utilities to define and control windows, input from the keyboard
and the mouse, drawing some geometric primitives (cubes, spheres, ...).
GLUT can even create pop-up windows.

%description -n	%{libglutname}-devel
Mesa is an OpenGL 1.4 compatible 3D graphics library.
glut parts.

This package contains the headers needed to compile Mesa programs.

%description -n	%{libglwname}
GLw adds Motif bindings to the OpenGL "canvas" (Xt/Motif/OpenGL widget code).

%description -n	%{libglwname}-devel
Mesa is an OpenGL 1.4 compatible 3D graphics library.
GLw parts.

This package contains the headers needed to compile Mesa programs.

%description	demos
Mesa is an OpenGL 1.4 compatible 3D graphics library.

This package contains some demo programs for the Mesa library.

%prep
%setup -q -n Mesa-%{version} -b1 -b2

%patch43 -p1 -b .no-ARB_render_texture
%patch2 -p1 -b .default_dri_dir

%if %{enable_egl}
%patch3 -p1 -b .egl_support
%endif

%patch6 -p0 -b .static_inline
%patch7 -p0 -b .0depth
%if "%{_lib}" != "lib"
%patch9 -p0 -b .staticinline
%endif
%patch10 -p1 -b .removebroken
%patch13 -p1 -b .linux-dri-config
%patch14 -p1 -b .google_earth_r300
%patch15 -p1 -b .mga_window_move

%patch44 -p1 -b .context

%patch100 -p1 -b .buildcfg
%patch101 -p1 -b .asm_pic
%patch102 -p1 -b .visualwarn
%patch103 -p1 -b .visibility
%patch104 -p1 -b .r300parallel
%patch105 -p1 -b .srccompat

%patch200 -p1 -b .git-i915tex-intelWindowMoved
%patch201 -p1 -b .git-i965-bug9045
%patch202 -p1 -b .git-i965-bug9237
%patch203 -p1 -b .git-i965-fix-crash-wine
%patch204 -p1 -b .git-i915tex-advertising
%patch205 -p1 -b .git-i965-sarea
%patch206 -p1 -b .git-i965-inteldebug
%patch207 -p1 -b .git-i965-flowmode
%patch208 -p1 -b .git-i965-ARB_occlusion_query
%patch209 -p1 -b .git-i965-maxprim
%patch210 -p1 -b .git-i965-bug9201
%patch211 -p1 -b .git-i965-bug9625
%patch212 -p1 -b .git-i915tex-randr-resizing
%patch213 -p1 -b .git-i915tex-relocation
%patch214 -p1 -b .git-i965-glxswapcontrol
%patch215 -p1 -b .git-i965-static-buffer-bug9604
%patch216 -p1 -b .git-i915-vertexfog-bug9686
%patch217 -p1 -b .git-mach64-bug7260
%patch218 -p1 -b .git-mach64-bug7790
%patch219 -p1 -b .git-mach64-bug7861
%patch220 -p1 -b .git-r200-WoW-bug8250
%patch221 -p1 -b .git-radeon-radeonClear
%patch222 -p1 -b .git-r300-fragprog
%patch223 -p1 -b .git-r300-fragprog-correct
%patch224 -p1 -b .git-r300-vertex-position
%patch225 -p1 -b .git-swrast-bug9345
%patch226 -p1 -b .git-VBO-state-bug9445
%patch227 -p1 -b .git-32bit-Z-buffer
%patch228 -p1 -b .git-PolygonMode-bug9578
%patch229 -p1 -b .git-CheckArrayBounds-bug9285
%patch230 -p1 -b .git-GetVertexAttribPointerv-bug9628
%patch231 -p1 -b .git-main-mem-leak
%patch232 -p1 -b .git-glxext-mem-leak
%patch233 -p1 -b .git-tnl-bug9856
%patch234 -p1 -b .git-fd-bug9684
%patch235 -p1 -b .git-n_dot_h-bug9977
%patch237 -p1 -b .git-unichrome-CN700
%patch238 -p1 -b .git-r300-call-radeonsetcliprects
%patch239 -p1 -b .git-radeon-adapt-cliprect-fixes
%patch240 -p1 -b .git-r200-call-radeonsetcliprects
%patch241 -p1 -b .git-r200-simplify-r200setcliprects
%patch242 -p1 -b .git-unichrome-screen-offset-bug9965
%patch243 -p1 -b .git-i915-add-i945gme
%patch244 -p1 -b .git-i915-add-g33
%patch245 -p1 -b .git-i965-add-i965gm
%patch246 -p1 -b .git-i965-add-i965gme
%patch247 -p1 -b .git-i965-badcast
%patch248 -p1 -b .git-nexuiz-sigsev-bug9170
%patch249 -p1 -b .git-i965-unorm-bug11742
%patch250 -p1 -b .git-fix-memleak-bug11791
%patch251 -p1 -b .git-fix-memleak-bug11793
%patch252 -p1 -b .git-fix-doublefree-bug11808
%patch253 -p1 -b .git-fix-invalid-pointer-in-bezier-bug11807
%patch254 -p1 -b .git-fix-overflow-stencil-value-bug11805
%patch255 -p1 -b .git-fix-swizzle-error-test-bug11881
%patch256 -p1 -b .git-unichrome-fix-potential-null-dereference-bug11879
%patch257 -p1 -b .git-i810-move-free-after-dereference-bug11878
%patch258 -p1 -b .git-fix-byte-swap-glint-stencil-bug11909
%patch259 -p1 -b .git-fix-spantmp-inline-asm-bug11931
%patch260 -p1 -b .git-i965-fix-segfault-with-max-texture-unit-bug9829
%patch261 -p1 -b .via_null_deref2
%patch262 -p1 -b .git-fix-segfault-in-display-list-bug11314
%patch263 -p1 -b .git-demos-fix-glutinit-calls-bug11486
%patch264 -p1 -b .git-fixlogic-op-bug11133
%patch265 -p1 -b .git-fix-GLX_STEREO-bug11705
%patch266 -p1 -b .git-fix-zoomed-depth-copies-bug10608
%patch267 -p1 -b .git-fix-negative-zoom-factor-bug10636
%patch268 -p1 -b .git-ARB_MESA-in-extension-check-bug10126

pushd progs/demos && {
	for i in *.c; do 
	perl -pi -e "s|\.\./images/|%{_libdir}/mesa-demos-data/|" $i ; 
	done 
	perl -pi -e "s|isosurf.dat|%{_libdir}/mesa-demos-data/isosurf.dat|" isosurf.c 
} && popd
pushd progs/xdemos && {
	for i in *.c; do 
	perl -pi -e "s|\.\./images/|%{_libdir}/mesa-demos-data/|" $i ; 
	done 
} && popd

chmod +x %{SOURCE3} %{SOURCE5}

%build
LIB_DIR=%{_lib}
INCLUDE_DIR=$RPM_BUILD_ROOT%{_includedir}
DRI_DRIVER_DIR="%{driver_dir}"
export LIB_DIR INCLUDE_DIR DRI_DRIVER_DIR

ARCH_FLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -DNDEBUG -DDEFAULT_DRIVER_DIR=\\\"%{driver_dir}\\\""
export ARCH_FLAGS

# (tv) parallel build is broken:
make 	MKDEP=/usr/bin/makedepend \
	USING_EGL=%{enable_egl} \
	DRI_DIRS=%{dri_drivers} \
	DRI_DRIVER_SEARCH_DIR=%{driver_dir} \
	LIB_DIR=$LIB_DIR \
	linux-dri

pushd progs/demos
%make LIB_DIR=$LIB_DIR
popd
pushd progs/xdemos
%make LIB_DIR=$LIB_DIR
popd

%install
LIB_DIR=%{_lib}
INCLUDE_DIR=$RPM_BUILD_ROOT%{_includedir}
DRI_DRIVER_DIR="%{_libdir}/dri"
export LIB_DIR INCLUDE_DIR DRI_DRIVER_DIR DRIMODULE_SRCDIR DRIMODULE_DESTDIR

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mesa-demos-data
mkdir -p $RPM_BUILD_ROOT%{_includedir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
make INSTALL_DIR=/$RPM_BUILD_ROOT%{_prefix} \
     DRI_DRIVER_INSTALL_DIR=$RPM_BUILD_ROOT$DRI_DRIVER_DIR \
     MKDEP=%{_bindir}/makedepend \
     USING_EGL=%{enable_egl} \
     DRI_DIRS=%{dri_drivers} \
     LIB_DIR=$LIB_DIR \
     install

mkdir -p $RPM_BUILD_ROOT%{_bindir}
for i in bounce clearspd drawpix engine gamma gears glinfo glutfx isosurf morph3d \
         multiarb paltex pointblast reflect renormal \
         spectex stex3d tessdemo texcyl texobj trispd winpos; do
  cp -v progs/demos/$i $RPM_BUILD_ROOT%{_bindir}
done

for i in glthreads glxdemo glxgears glxgears_fbconfig glxcontexts glxheads \
        glxinfo glxpixmap glxpbdemo glxswapcontrol manywin offset overlay \
        pbinfo pbdemo wincopy xfont xrotfontdemo yuvrect_client; do
  cp -v progs/xdemos/$i $RPM_BUILD_ROOT%{_bindir} 
done

# (fg) So that demos at least work :)
cp -v progs/images/*rgb progs/demos/isosurf.dat $RPM_BUILD_ROOT%{_libdir}/mesa-demos-data

# (blino) hardlink libGL files in %{_libdir}/mesa
# to prevent proprietary driver installers from removing them
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mesa
pushd $RPM_BUILD_ROOT%{_libdir}/mesa
for l in ../libGL.so.*; do cp -a $l .; done
popd

# (gb) use update-alternatives to manage several GL libraries/drivers
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/GL/
cat > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf << EOF
# This file is knowingly empty since %{_libdir} is a standard search path
EOF
touch $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/GL.conf

# icons for three demos examples [we lack a frontend
# to launch the demos obviously]
install -m 755 -d $RPM_BUILD_ROOT%{_miconsdir}
install -m 755 -d $RPM_BUILD_ROOT%{_iconsdir}
install -m 755 -d $RPM_BUILD_ROOT%{_liconsdir}
tar jxvf %{SOURCE4} -C $RPM_BUILD_ROOT%{_iconsdir}

# clean any .la file with still reference to tmppath.
perl -pi -e "s|\S+$RPM_BUILD_DIR\S*||g" $RPM_BUILD_ROOT/%{_libdir}/*.la

# generate mesa source files
%{SOURCE3} $RPM_BUILD_ROOT %{mesasrcdir}


%clean
rm -fr $RPM_BUILD_ROOT

%if %{enable_egl}
%post -n %{libeglname} -p /sbin/ldconfig
%postun -n %{libeglname} -p /sbin/ldconfig
%endif

%post -n %{libglname}
/usr/sbin/update-alternatives --install %{_sysconfdir}/ld.so.conf.d/GL.conf gl_conf %{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf %{priority}
if [ ! -L %{_sysconfdir}/ld.so.conf.d/GL.conf ]; then
  /usr/sbin/update-alternatives --auto gl_conf
fi
/sbin/ldconfig

%postun -n %{libglname}
if [ ! -f %{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf ]; then
  /usr/sbin/update-alternatives --remove gl_conf %{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf
fi
/sbin/ldconfig

%post -n %{libgluname} -p /sbin/ldconfig 

%postun -n %{libgluname} -p /sbin/ldconfig

%post -n %{libglutname} -p /sbin/ldconfig 

%postun -n %{libglutname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc docs/COPYING docs/README.*
%doc docs/RELNOTES-3* docs/RELNOTES-4.* 

%files source -f mesa-source-rpm-filelist.lst
%defattr(-,root,root)
%doc docs/COPYING

%if %{enable_egl}
%files -n %{libeglname}
%defattr(-,root,root)
%{_libdir}/libegl.so.1*
%{_libdir}/libegldri.so.1*

%files -n %{libeglname}-devel
%defattr(-,root,root)
%{_libdir}/libegl.so
%{_libdir}/libegldri.so
%{_includedir}/gles/egl*.h
%endif

%files -n %{libglname}
%defattr(-,root,root)
%doc docs/COPYING
%ghost %{_sysconfdir}/ld.so.conf.d/GL.conf
%config %{_sysconfdir}/ld.so.conf.d/GL/%{libglname}.conf
%{_libdir}/libGL.so.*
%dir %{_libdir}/mesa
%{_libdir}/mesa/libGL.so.*
%ifnarch ppc64
%dir %{_libdir}/dri
%{_libdir}/dri/*
%endif
%ifarch %{ix86}
#%{_libdir}/modules/*
%endif

%files -n %{libglname}-devel
%defattr(-,root,root)
%doc docs/COPYING
%{_includedir}/GL/gl.h
%{_includedir}/GL/glext.h
%{_includedir}/GL/gl_mangle.h
%{_includedir}/GL/osmesa.h
%ifnarch ia64 alpha
%{_includedir}/GL/svgamesa.h
%endif
%{_includedir}/GL/glx.h
%{_includedir}/GL/glxext.h
%{_includedir}/GL/glx_mangle.h
%{_includedir}/GL/xmesa.h
%{_includedir}/GL/xmesa_x.h
%{_includedir}/GL/xmesa_xf86.h
%{_libdir}/libGL.so

#FIXME: check those headers
%{_includedir}/GL/mglmesa.h
%{_includedir}/GL/amesa.h
%{_includedir}/GL/dmesa.h
%{_includedir}/GL/fxmesa.h
%{_includedir}/GL/ggimesa.h
%{_includedir}/GL/glfbdev.h
%{_includedir}/GL/uglglutshapes.h
%{_includedir}/GL/uglmesa.h
%{_includedir}/GL/vms_x_fix.h
%{_includedir}/GL/wmesa.h

%files -n %{libgluname}
%defattr(-,root,root)
%doc docs/COPYING
%{_libdir}/libGLU.so.*

%files -n %{libglutname}
%defattr(-,root,root)
%doc docs/COPYING
%{_libdir}/libglut.so.*

%files -n %{libglwname}
%defattr(-,root,root)
%doc docs/COPYING
%{_libdir}/libGLw.so.*


%files -n %{libgluname}-devel
%defattr(-,root,root)
%doc docs/COPYING
%{_includedir}/GL/glu.h
%{_includedir}/GL/glu_mangle.h
%{_includedir}/GL/mesa_wgl.h
%{_libdir}/libGLU.so

%files -n %{libglutname}-devel
%defattr(-,root,root)
%doc docs/COPYING
%{_includedir}/GL/glut.h
%{_includedir}/GL/glutf90.h
%{_libdir}/libglut.so

%files common-devel
%defattr(-,root,root)

%files -n %{libglwname}-devel
%defattr(-,root,root)
%doc docs/COPYING
%{_includedir}/GL/GLwDrawA.h
%{_includedir}/GL/GLwDrawAP.h
%{_includedir}/GL/GLwMDrawA.h
%{_includedir}/GL/GLwMDrawAP.h
%{_libdir}/libGLw.so

%files demos
%defattr(-,root,root)
%doc docs/COPYING
%{_bindir}/*
%dir %{_libdir}/mesa-demos-data
%{_libdir}/mesa-demos-data/*
%{_miconsdir}/*demos*.png
%{_iconsdir}/*demos*.png
%{_liconsdir}/*demos*.png




%changelog
* Thu Aug 23 2007 Giuseppe Ghibò <ghibo@mandriva.com> 6.5.2-9mdv2007.1
+ Revision: 70113
- Patch247: i965: fix bad casts in do_blit_bitmap to support WindowPos correctly
- Patch248: fix r300 SIGSEV while running nexuiz (bug MESA#9170)
- Patch249: i965: Use I16_UNORM instead of L16_UNORM (bug MESA#11742).
- Patch250: fix memleak in glut (bug MESA#11791).
- Patch251: fix memleak in dri (bug MESA#11793).
- Patch252: fix memleak/double free in glu (bug MESA#11808).
- Patch253: fix invalid pointer (use after free) in GLU (bug MESA#11807).
- Patch254: fix overflow when reading pixels from stencil buffer (bug MESA#11805).
- Patch255: fix logic in atifragshader test (bug MESA#11881).
- Patch256: unichrome: fix potential NULL dereference (bug MESA#11879).
- Patch257: i810: fix code usage after free()(bug MESA#11878).
- Patch258: fix byte swap bug for GLint stencil indexes (bug MESA#11909).
- Patch259: fix spantmp2 READ_RGBA inline asm (bug MESA#11931).
- Patch260: i965. fix segfaults with max texture unit (bug MESA#9829).
- Patch261: unichrome: fix NULL pointer dereference (from blino, bug MESA#12097).
- Patch262: fix segfault when call DrawElement in a display list (bug MESA#11314).
- Patch263: fix glutInit calls in some demos (bug MESA#11486).
- Patch264: glLogicOp not applied when draw bitmap (bug MESA#11133).
- Patch265: fix GLX_STEREO handling (bug MESA#11705).
- Patch266: fix zoomed depth copies (bug MESA#10608).
- Patch267: fix negative zoom factor bug (bug MESA#10636).
- Patch268: fix winpos demo (bug MESA#10126).
- copy mesa to 2007.1 backports
- Patch238: call RadeonSetCliprects and ensure framebuffer has the correct size (from Mesa git).
- Patch239: radeon: adapt cliprect fixes from r300 (from Mesa git).
- Patch240: r200: adapt cliprect fixes from r300 (from Mesa git).
- Patch241: Simplify r200SetCliprects like radeonSetCliprects in radeon and r300 (from Mesa git).
- Patch242: unicrome: fix window at double coordinates (bug MESA#9965).
- Patch243: i915: add support for Intel 945GME (from Mesa git).
- Patch244: i915: Add PCI IDs for the G33, Q33, and Q35 chipsets (from Mesa git).
- Patch245: i965: Add Intel i965GM chipset info (from Mesa git).
- Patch246: i965: Add Intel i965GME chipset info (from Mesa git).
- Merged Patch100-105 from Fedora.
- Merged Patch200-237 from Sisyphus (extracted from Mesa git).

  + Andreas Hasenack <andreas@mandriva.com>
    - branched cooker into 2007.1 (will have to revert some recent changes)

